// Code generated by protoc-gen-micro. DO NOT EDIT.
// source: proto/try-go-micro.proto

package trygomicro

import (
	fmt "fmt"
	proto "github.com/golang/protobuf/proto"
	math "math"
)

import (
	context "context"
	api "github.com/micro/micro/v3/service/api"
	client "github.com/micro/micro/v3/service/client"
	server "github.com/micro/micro/v3/service/server"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.ProtoPackageIsVersion3 // please upgrade the proto package

// Reference imports to suppress errors if they are not otherwise used.
var _ api.Endpoint
var _ context.Context
var _ client.Option
var _ server.Option

// Api Endpoints for TryGoMicro service

func NewTryGoMicroEndpoints() []*api.Endpoint {
	return []*api.Endpoint{}
}

// Client API for TryGoMicro service

type TryGoMicroService interface {
	Call(ctx context.Context, in *Request, opts ...client.CallOption) (*Response, error)
	Stream(ctx context.Context, in *StreamingRequest, opts ...client.CallOption) (TryGoMicro_StreamService, error)
	PingPong(ctx context.Context, opts ...client.CallOption) (TryGoMicro_PingPongService, error)
}

type tryGoMicroService struct {
	c    client.Client
	name string
}

func NewTryGoMicroService(name string, c client.Client) TryGoMicroService {
	return &tryGoMicroService{
		c:    c,
		name: name,
	}
}

func (c *tryGoMicroService) Call(ctx context.Context, in *Request, opts ...client.CallOption) (*Response, error) {
	req := c.c.NewRequest(c.name, "TryGoMicro.Call", in)
	out := new(Response)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *tryGoMicroService) Stream(ctx context.Context, in *StreamingRequest, opts ...client.CallOption) (TryGoMicro_StreamService, error) {
	req := c.c.NewRequest(c.name, "TryGoMicro.Stream", &StreamingRequest{})
	stream, err := c.c.Stream(ctx, req, opts...)
	if err != nil {
		return nil, err
	}
	if err := stream.Send(in); err != nil {
		return nil, err
	}
	return &tryGoMicroServiceStream{stream}, nil
}

type TryGoMicro_StreamService interface {
	Context() context.Context
	SendMsg(interface{}) error
	RecvMsg(interface{}) error
	Close() error
	Recv() (*StreamingResponse, error)
}

type tryGoMicroServiceStream struct {
	stream client.Stream
}

func (x *tryGoMicroServiceStream) Close() error {
	return x.stream.Close()
}

func (x *tryGoMicroServiceStream) Context() context.Context {
	return x.stream.Context()
}

func (x *tryGoMicroServiceStream) SendMsg(m interface{}) error {
	return x.stream.Send(m)
}

func (x *tryGoMicroServiceStream) RecvMsg(m interface{}) error {
	return x.stream.Recv(m)
}

func (x *tryGoMicroServiceStream) Recv() (*StreamingResponse, error) {
	m := new(StreamingResponse)
	err := x.stream.Recv(m)
	if err != nil {
		return nil, err
	}
	return m, nil
}

func (c *tryGoMicroService) PingPong(ctx context.Context, opts ...client.CallOption) (TryGoMicro_PingPongService, error) {
	req := c.c.NewRequest(c.name, "TryGoMicro.PingPong", &Ping{})
	stream, err := c.c.Stream(ctx, req, opts...)
	if err != nil {
		return nil, err
	}
	return &tryGoMicroServicePingPong{stream}, nil
}

type TryGoMicro_PingPongService interface {
	Context() context.Context
	SendMsg(interface{}) error
	RecvMsg(interface{}) error
	Close() error
	Send(*Ping) error
	Recv() (*Pong, error)
}

type tryGoMicroServicePingPong struct {
	stream client.Stream
}

func (x *tryGoMicroServicePingPong) Close() error {
	return x.stream.Close()
}

func (x *tryGoMicroServicePingPong) Context() context.Context {
	return x.stream.Context()
}

func (x *tryGoMicroServicePingPong) SendMsg(m interface{}) error {
	return x.stream.Send(m)
}

func (x *tryGoMicroServicePingPong) RecvMsg(m interface{}) error {
	return x.stream.Recv(m)
}

func (x *tryGoMicroServicePingPong) Send(m *Ping) error {
	return x.stream.Send(m)
}

func (x *tryGoMicroServicePingPong) Recv() (*Pong, error) {
	m := new(Pong)
	err := x.stream.Recv(m)
	if err != nil {
		return nil, err
	}
	return m, nil
}

// Server API for TryGoMicro service

type TryGoMicroHandler interface {
	Call(context.Context, *Request, *Response) error
	Stream(context.Context, *StreamingRequest, TryGoMicro_StreamStream) error
	PingPong(context.Context, TryGoMicro_PingPongStream) error
}

func RegisterTryGoMicroHandler(s server.Server, hdlr TryGoMicroHandler, opts ...server.HandlerOption) error {
	type tryGoMicro interface {
		Call(ctx context.Context, in *Request, out *Response) error
		Stream(ctx context.Context, stream server.Stream) error
		PingPong(ctx context.Context, stream server.Stream) error
	}
	type TryGoMicro struct {
		tryGoMicro
	}
	h := &tryGoMicroHandler{hdlr}
	return s.Handle(s.NewHandler(&TryGoMicro{h}, opts...))
}

type tryGoMicroHandler struct {
	TryGoMicroHandler
}

func (h *tryGoMicroHandler) Call(ctx context.Context, in *Request, out *Response) error {
	return h.TryGoMicroHandler.Call(ctx, in, out)
}

func (h *tryGoMicroHandler) Stream(ctx context.Context, stream server.Stream) error {
	m := new(StreamingRequest)
	if err := stream.Recv(m); err != nil {
		return err
	}
	return h.TryGoMicroHandler.Stream(ctx, m, &tryGoMicroStreamStream{stream})
}

type TryGoMicro_StreamStream interface {
	Context() context.Context
	SendMsg(interface{}) error
	RecvMsg(interface{}) error
	Close() error
	Send(*StreamingResponse) error
}

type tryGoMicroStreamStream struct {
	stream server.Stream
}

func (x *tryGoMicroStreamStream) Close() error {
	return x.stream.Close()
}

func (x *tryGoMicroStreamStream) Context() context.Context {
	return x.stream.Context()
}

func (x *tryGoMicroStreamStream) SendMsg(m interface{}) error {
	return x.stream.Send(m)
}

func (x *tryGoMicroStreamStream) RecvMsg(m interface{}) error {
	return x.stream.Recv(m)
}

func (x *tryGoMicroStreamStream) Send(m *StreamingResponse) error {
	return x.stream.Send(m)
}

func (h *tryGoMicroHandler) PingPong(ctx context.Context, stream server.Stream) error {
	return h.TryGoMicroHandler.PingPong(ctx, &tryGoMicroPingPongStream{stream})
}

type TryGoMicro_PingPongStream interface {
	Context() context.Context
	SendMsg(interface{}) error
	RecvMsg(interface{}) error
	Close() error
	Send(*Pong) error
	Recv() (*Ping, error)
}

type tryGoMicroPingPongStream struct {
	stream server.Stream
}

func (x *tryGoMicroPingPongStream) Close() error {
	return x.stream.Close()
}

func (x *tryGoMicroPingPongStream) Context() context.Context {
	return x.stream.Context()
}

func (x *tryGoMicroPingPongStream) SendMsg(m interface{}) error {
	return x.stream.Send(m)
}

func (x *tryGoMicroPingPongStream) RecvMsg(m interface{}) error {
	return x.stream.Recv(m)
}

func (x *tryGoMicroPingPongStream) Send(m *Pong) error {
	return x.stream.Send(m)
}

func (x *tryGoMicroPingPongStream) Recv() (*Ping, error) {
	m := new(Ping)
	if err := x.stream.Recv(m); err != nil {
		return nil, err
	}
	return m, nil
}
